aboutsummaryrefslogtreecommitdiffstats
path: root/resources/libraries/bash/function
diff options
context:
space:
mode:
authorVratko Polak <vrpolak@cisco.com>2021-12-15 17:14:36 +0100
committerVratko Polak <vrpolak@cisco.com>2021-12-15 17:14:36 +0100
commit01d8f262afc567c3d49a23c3cb2cdeaced8a6887 (patch)
tree0449c972d8201be16d648dd749e0a7d116aa8b71 /resources/libraries/bash/function
parentcca05a55f3434d8a031b98f4a496adb8df20c122 (diff)
UTI: Export results
+ Model version 1.0.0. - Only some result types are exported. + MRR, NDRPDR and SOAK. - Other result types to be added later. + In contrast, all test types are detected. + Convert custom classes to JSON-serializable equivalents. + Sort dict keys before converting to JSON. + Override the order for some known keys. + Export sets as sorted arrays. + Convert to info content from serialized raw content. + Also export outputs for suite setups and teardowns. + Info files for setup/teardown exist only temporarily. + The data is merged into suite.info.json file. + This simplifies presentation of total suite duration. + Define model via JSON schema: - Just test case, suite setup/teardown/suite to be added later. - Just info, raw to be added later. + Proper descriptions. + Json is generated from yaml. + This is a convenience for maintainers. + The officially used schema is the .json one. + TODOs written into a separate .txt file. + Validate exported instance against the schema. + Include format checking. + Update CSIT requirements for validation dependencies. + This needs python-dateutil==2.8.2, only a patch bump. + Compute bandwidth also for soak tests. + This unifies with NDRPDR to simplify schema definition. - PAL may need an update for parsing soak test message. + Include SSH log items, raw output only. + Generate all outputs in a single filesystem tree. + Move raw outputs into test_output_raw.tar.xz. + Rename existing tar with suites to generated_robot_files.tar.xz. Change-Id: I69ff7b330ed1a14dc435fd0ef008e753c0d7f78c Signed-off-by: Vratko Polak <vrpolak@cisco.com>
Diffstat (limited to 'resources/libraries/bash/function')
-rw-r--r--resources/libraries/bash/function/common.sh29
-rw-r--r--resources/libraries/bash/function/per_patch.sh4
2 files changed, 31 insertions, 2 deletions
diff --git a/resources/libraries/bash/function/common.sh b/resources/libraries/bash/function/common.sh
index 7348f25c47..0a4c94969d 100644
--- a/resources/libraries/bash/function/common.sh
+++ b/resources/libraries/bash/function/common.sh
@@ -147,7 +147,8 @@ function archive_tests () {
set -exuo pipefail
- tar c "${GENERATED_DIR}/tests" | xz -3 > "${ARCHIVE_DIR}/tests.tar.xz" || {
+ filename="generated_robot_files.tar.xz"
+ tar c "${GENERATED_DIR}/tests" | xz -3 > "${ARCHIVE_DIR}/${filename}" || {
die "Error creating archive of generated tests."
}
}
@@ -713,6 +714,8 @@ function run_pybot () {
# Run pybot with options based on input variables. Create output_info.xml
#
+ # Also, .info.json files are moved into an archive to speed up PAL.
+ #
# Variables read:
# - CSIT_DIR - Path to existing root of local CSIT git repository.
# - ARCHIVE_DIR - Path to store robot result files in.
@@ -735,7 +738,31 @@ function run_pybot () {
PYBOT_EXIT_STATUS="$?"
set -e
+ # Compress raw json outputs, if any.
+ pushd "${ARCHIVE_DIR}" || die
+ if [ -d "tests" ]; then
+ # Use deterministic order.
+ options+=("--sort=name")
+ # We are keeping info outputs where they are.
+ # Assuming we want to move anything but info files (and dirs).
+ options+=("--exclude=*.info.json")
+ # There may be other unforeseen errors,
+ # we still want to execute subsequent commands, so disable set -e.
+ set +e
+ tar cvf "tests_output_raw.tar" "${options[@]}" "tests"
+ # If compression fails, it leaves an uncompressed .tar,
+ # we still want to archive that to investigate why compression failed.
+ time xz -9e "tests_output_raw.tar"
+ # Tar can remove when archiving, but chokes (not deterministically)
+ # on attempting to remove dirs (not empty as info files are there).
+ # So we need to delete the raw files manually.
+ find "tests" -type f -name "*.raw.json" -delete
+ set -e
+ fi
+ popd || die
+
# Generate INFO level output_info.xml for post-processing.
+ # This comes last, as it is slowest, and sometimes users abort here.
all_options=("--loglevel" "INFO")
all_options+=("--log" "none")
all_options+=("--report" "none")
diff --git a/resources/libraries/bash/function/per_patch.sh b/resources/libraries/bash/function/per_patch.sh
index 4af3302008..b6a572d654 100644
--- a/resources/libraries/bash/function/per_patch.sh
+++ b/resources/libraries/bash/function/per_patch.sh
@@ -37,7 +37,9 @@ function archive_test_results () {
cd "${VPP_DIR}" || die "Change directory command failed."
TARGET="$(readlink -f "$1")"
mkdir -p "${TARGET}" || die "Directory creation failed."
- for filename in "output.xml" "log.html" "report.html"; do
+ file_list=("output.xml" "log.html" "report.html")
+ file_list+=("tests" "tests_output_raw.tar.xz")
+ for filename in "${file_list[@]}"; do
mv "${ARCHIVE_DIR}/${filename}" "${TARGET}/${filename}" || {
die "Attempt to move '${filename}' failed."
}